/* s1m.h
	17 July 98
*/

#include <stdio.h>
#include <string.h>

#define MXMS	29      /* max micro store */
#define MXSTR 	80	/* max string length */
#define MSW	31	/* micro store width */

/* control bit position in microword */

#define	DR	0
#define DPC	1
#define DIR     2
#define DMAR    3
#define DMDR    4
#define SR      5
#define SPC     6
#define SIR     7
#define SMAR    8
#define SMDR    9
#define ST      10
#define IRR0    11
#define IRR1    12
#define IRR2    13
#define IR12    14
#define PASS1   15
#define ADD     16
#define SUB     17
#define ADD1    18
#define MRD     19
#define MWR     20
#define PC1     21
#define U       22
#define MRDY    23
#define TESTCC  24
#define DECODE  25
#define GOTO	26

/* microinstruction address in microprogram */
#define UIFETCH 0
#define ULOAD	3
#define USTORE  6
#define ULOADR  10
#define USTORER 13
#define UMOV    17
#define UADD    19
#define UCMP    21
#define UINC    22
#define UJMP    24
#define UJAL    26
#define UJR     28
#define UTRAP   MXMS+1
#define UNDEF	MXMS+2

/* opcode */
#define ILOAD	0
#define ISTORE  1
#define IJMP    2
#define IJAL    3
#define IXOP    7
#define IMOV    0
#define ILOADR  1
#define ISTORER 2
#define IADD    3
#define ICMP    4
#define IINC    5
#define IJR     6
#define ITRAP   7
